<?php

/**
 * alerta_auto_enlace actions.
 *
 * @package    canon
 * @subpackage alerta_auto_enlace
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class alerta_auto_enlaceActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */

            $whereAprobadoRev = ' ';
            if (isset($request['id_estado_rev'])) {
                $whereAprobadoRev = " AND tab0.id_estado_rev = '" . $request['id_estado_rev'] . "' ";
            }

            //Solo canones sin gestion - 20170629
//            $whereSinGestion = ' ';
//            if (isset($request['sin_gestion']) && $request['sin_gestion'] == "true") {
            $whereSinGestion = " AND tab0.id_estado_rev is null";
//            }

            $whereTitulo = ' ';
            if (isset($request['id_titulo'])) {
                $whereTitulo = " AND tab0.id_titulo = '" . $request['id_titulo'] . "' ";
            }

            $whereCompetencia = ' ';
            if (isset($request['id_competencia'])) {
                $whereCompetencia = " AND tab0.id_competencia = '" . $request['id_competencia'] . "' ";
            }

            $whereCompetenciaUsuario = ' ';
            if (isset($request['id_usuario'])) {
                $whereCompetenciaUsuario = " AND tab0.id_competencia in ( select id_competencia from ca_usuario_competencia where id_usuario = " . $request['id_usuario'] . " ) ";
            }


            /**
             * Revisa el mes siguiente - 20170629
             * • Faltando 10 días para el inicio de la anualidad
             * • Faltando 5 días para el inicio de la anualidad
             */
            $dia1 = 10;
            $dia2 = 5;
            $anho_completo = date('Y'); //anho completo cuatro digitos
            $mes = date('m'); //mes con dos digitos
            $fechaSiguiente = CN_TABLE::fechaSiguiente($anho_completo, $mes);
            $anho_completo = $fechaSiguiente['id_anhos'];
            $mes = $fechaSiguiente['id_meses'];

            $request['fecha_inicio_anu'] = $anho_completo . '-' . $mes . '-01';
            $request['fecha_fin_anu'] = $anho_completo . '-' . $mes . '-01';
            $whereFechaAnu = '';
            if (isset($request['fecha_inicio_anu']) && isset($request['fecha_fin_anu'])) {

                $fecha_ini = explode('-', $request['fecha_inicio_anu']);
                $fecha_fin = explode('-', $request['fecha_fin_anu']);
                $fecha_ini = $fecha_ini[2] . "/" . $fecha_ini[1] . "/" . $fecha_ini[0];
                $fecha_fin = $fecha_fin[2] . "/" . $fecha_fin[1] . "/" . $fecha_fin[0];

                $whereFechaAnu = " and tab0.fecha_inicio between to_date( '" . $fecha_ini . "' , 'dd/mm/yyyy' ) and "
                        . "LAST_DAY(to_date( '" . $fecha_fin . "' , 'dd/mm/yyyy' )) ";
            } elseif (isset($request['id_meses']) && isset($request['id_anhos'])) {
                $id_meses = $request['id_meses'];
                $id_anhos = $request['id_anhos'];
                $whereFechaAnu = " and tab0.fecha_inicio between to_date('01/'||$id_meses||'/'||$id_anhos, 'dd/mm/yyyy') and "
                        . "LAST_DAY(to_date('01/'||$id_meses||'/'||$id_anhos, 'dd/mm/yyyy'))";
            }

            $query = "
select 
tab0.* 
from ( 

    select 
    ae.fecha_inicio - $dia1 as fecha_comp1,
    ae.fecha_inicio - $dia2 as fecha_comp2,
    tit.id_titulo, tit.cod_exp, tit.fecha_inscripcion_rmn as fecha_inscripcion_rmn,
    nc.descripcion as desc_norma, m.nombre as desc_modalidad, ae.fecha_inicio, ae.fecha_fin,
    to_char(ae.fecha_inicio, 'YYYY-MM-DD') as fecha_inicio_anu, to_char(ae.fecha_fin, 'YYYY-MM-DD') as fecha_fin_anu, ae.anualidad,
    e.nombre as desc_etapa, cmp.nombre as desc_competencia,
    ta.area/10000 as area_actual, dlr.valor,
    est.descripcion as desc_estado_rev,
    case
    when dlr.valor=0 then nvl(est.observaciones,'No se registra salario mínimo legal vigente para este año')
    else est.observaciones
    end as observaciones, ae.id_anual_etapa,
    est.id_estado_rev,
    cmp.id_competencia,
    est.id_novedad_rev_tit,
    est.fecha_rev,
    est.id_usuario_rev
    from ca_titulo_etapa te
    
    join ca_etapa e on te.id_etapa=e.id_etapa
    --join ca_anual_etapa ae on ae.id_titulo_etapa =te.id_titulo_etapa and te.actual = 1 and ae.estado = 1 and ae.liquidado = 0
    join ca_anual_etapa ae on ae.id_titulo_etapa =te.id_titulo_etapa and te.actual = 1 and ae.liquidado = 0
    join in_titulo_competencia tc on tc.id_titulo = te.id_titulo and tc.actual = 1
    join rmn_competencia cmp on cmp.id_competencia = tc.id_competencia
    join rmn_titulo tit on tit.id_titulo= te.id_titulo
    join ca_titulo_norma tn on tn.id_titulo=te.id_titulo and tn.actual=1
    join ca_norma_canon nc on nc.id_norma = tn.id_norma
    join rmn_titulo_modalidad tm on tm.id_titulo = te.id_titulo and tm.actual=1
    join rmn_modalidad m on m.id_modalidad = tm.id_modalidad
    join in_titulo_area ta on ta.id_titulo=te.id_titulo and ta.actual=1
    join ca_det_liq_repo_canon dlr on dlr.id_anual_etapa = ae.id_anual_etapa
    left join(
    select * from
    (
    select nrev.id_novedad_rev_tit, nrev.id_anual_etapa, erev.descripcion, erev.id_estado_rev, nrev.fecha_rev, nrev.id_usuario_rev, nrev.observaciones,
    ROW_NUMBER() OVER (PARTITION BY id_anual_etapa ORDER BY fecha_rev desc, id_novedad_rev_tit desc) rno
    from ca_novedad_rev_tit nrev
    join ca_estado_rev erev on nrev.id_estado_rev = erev.id_estado_rev
    )
    where rno=1
    )est on est.id_anual_etapa=ae.id_anual_etapa
    
    where 
    1 = 1
    --and cmp.num_doc in ('8999992948', '8904800591', '8918004981', '8908010521', '8923999999', '8905014342', '9005000182')
    and cmp.activo = 1
    and tit.fecha_ter > ae.fecha_inicio
    
    union
    
    select 
    ae.fecha_inicio - $dia1 as fecha_comp1,
    ae.fecha_inicio - $dia2 as fecha_comp2,
    tit.id_titulo, tit.cod_exp, tit.fecha_inscripcion_rmn as fecha_inscripcion_rmn,
    nc.descripcion as desc_norma, m.nombre as desc_modalidad,  ae.fecha_inicio, ae.fecha_fin,
    to_char(ae.fecha_inicio, 'YYYY-MM-DD') as fecha_inicio_anu, to_char(ae.fecha_fin, 'YYYY-MM-DD') as fecha_fin_anu, ae.anualidad,
    e.nombre as desc_etapa, cmp.nombre as desc_competencia,
    ta.area/10000 as area_actual, dlr.valor,
    est.descripcion as desc_estado_rev,
    case
    when dlr.valor=0 then nvl(est.observaciones,'No se registra salario mínimo legal vigente para este año')
    else est.observaciones
    end as observaciones, ae.id_anual_etapa,
    est.id_estado_rev,
    cmp.id_competencia,
    est.id_novedad_rev_tit,
    est.fecha_rev,
    est.id_usuario_rev
    from ca_titulo_etapa te
    
    join ca_etapa e on te.id_etapa=e.id_etapa
    --join ca_anual_etapa ae on ae.id_titulo_etapa =te.id_titulo_etapa and te.actual = 1 and ae.estado = 1 and ae.liquidado = 0
    join ca_anual_etapa ae on ae.id_titulo_etapa =te.id_titulo_etapa and te.actual = 1 and ae.liquidado = 1
    join in_titulo_competencia tc on tc.id_titulo = te.id_titulo and tc.actual = 1
    join rmn_competencia cmp on cmp.id_competencia = tc.id_competencia
    join rmn_titulo tit on tit.id_titulo= te.id_titulo
    join ca_titulo_norma tn on tn.id_titulo=te.id_titulo and tn.actual=1
    join ca_norma_canon nc on nc.id_norma = tn.id_norma
    join rmn_titulo_modalidad tm on tm.id_titulo = te.id_titulo and tm.actual=1
    join rmn_modalidad m on m.id_modalidad = tm.id_modalidad
    join in_titulo_area ta on ta.id_titulo=te.id_titulo and ta.actual=1
    join ca_det_liq_repo_canon dlr on dlr.id_anual_etapa = ae.id_anual_etapa
    join(
    select * from
    (
    select nrev.id_novedad_rev_tit, nrev.id_anual_etapa, erev.descripcion, erev.id_estado_rev, nrev.fecha_rev, nrev.id_usuario_rev, nrev.observaciones,
    ROW_NUMBER() OVER (PARTITION BY id_anual_etapa ORDER BY fecha_rev desc, id_novedad_rev_tit desc) rno
    from ca_novedad_rev_tit nrev
    join ca_estado_rev erev on nrev.id_estado_rev = erev.id_estado_rev
    )
    where rno=1
    )est on est.id_anual_etapa=ae.id_anual_etapa
    
    where 
    1 = 1
    --and cmp.num_doc in ('8999992948', '8904800591', '8918004981', '8908010521', '8923999999', '8905014342', '9005000182')
    and cmp.activo = 1
    and tit.fecha_ter > ae.fecha_inicio

)tab0

where 
1 = 1 
$whereFechaAnu
$whereAprobadoRev $whereSinGestion $whereTitulo $whereCompetencia
$whereCompetenciaUsuario    

and (
  fecha_comp1 = trunc(sysdate) 
  or 
  fecha_comp2 = trunc(sysdate) 
)

order by 
tab0.fecha_inicio,
tab0.cod_exp";

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
$query      
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
$query     
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_novedad_rev_tit');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INF_CAN_PROX_CAUS] Consulta exitosa.");
            } else {

                $mensaje = "[INF_CAN_PROX_CAUS] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[INF_CAN_PROX_CAUS] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
